ext WaitTimer_

Port_Sound equ 206H
tempo equ 160

dseg
SoundProc:
    defw 0

; void InitSound();
cseg
InitSound_: public InitSound_
    mov word ptr[SoundProc],0
ret


; void CallSound();
CallSound_: public CallSound_
cseg
    push ax
        mov ax,[SoundProc]
        or ax,ax
        if nz
            call ax
            mov word ptr [SoundProc],0
        endif
    pop ax
ret


cseg
Tone: ; cx=cycle, bx=length
    push dx
        mov al,3
        cli
            mov dx,Port_Sound
            do
                push cx
                    out dx,al
                    do | wloop
                pop cx
                dec bx
            while nz | wend
        sti
    pop dx
ret

Rest: ; cx=cycle, bx=length
    push dx
        mov al,3
        cli
            mov dx,Port_Sound
            do
                push cx
                    in al,dx
                    do | wloop
                pop cx
                dec bx
            while nz | wend
        sti
    pop dx
ret


; void Sound_Loose();
cseg
Sound_Loose_: public Sound_Loose_
    push ax | push bx | push cx
        mov cx,300*2
        mov bx,100/2
        call Tone
        mov al,1 | call WaitTimer_
    pop cx | pop bx | pop ax
ret


; void Sound_Hit();
cseg
Sound_Hit_: public Sound_Hit_
    push ax | push bx | push cx
        mov cx,300*2
        do
            push cx
                mov bx,10
                call Tone
            pop cx
            sub cx,20
            cmp cx,300
        while nc | wend
    pop cx | pop bx | pop ax
ret


; void Sound_Beep();
cseg
Sound_Beep_: public Sound_Beep_
    push ax | push bx | push cx
        mov cx,300
        mov bx,100
        call Tone
        mov al,1 | call WaitTimer_
    pop cx | pop bx | pop ax
ret


cseg
Melody:
    push ax | push bx | push cx | push dx
        do
            mov dl,[si] | inc si
            or dl,dl
        while ne
            mov al,[si] | inc si
            or al,al
            if nz
                dec al
                shl al,1 | shl al,1
                xor ah,ah
                add ax,cycles
                mov bx,ax
                mov cx,[bx]
                mov al,[bx+2]
                mul dl
                mov bx,ax
                call Tone
            else
                mov cx,[cycles]
                mov al,[cycles+2]
                mul dl
                mov bx,ax
                call Rest
            endif
        wend
    pop dx | pop cx | pop bx | pop ax
ret


; void Sound_Start();
cseg
start_notes: public start_notes
	defb 6,0, 5,C5,1,0, 5,C5,1,0, 5,C5,1,0
	defb 5,C5,1,0, 11,G4,1,0, 11,C5,1,0
	defb 5,C5,1,0, 5,D5,1,0, 5,C5,1,0, 11,D5,1,0
	defb 11,E5,1,0, 24,C5,47-24,C5,1,0
    defb 0
Sound_Start_: public Sound_Start_
    mov si,start_notes
jmp Melody


; void Sound_Clear();
clear_notes: 
	defb 5,C4,1,0, 5,E4,1,0, 5,G4,1,0, 5,D4,1,0
	defb 5,F4,1,0, 5,A4,1,0, 5,E4,1,0, 5,G4,1,0
	defb 5,B4,1,0, 17,C5,1,0
    defb 0
Sound_Clear_: public Sound_Clear_
    mov si,clear_notes
jmp Melody


; void Sound_GameOver();
cseg
over_notes: 
	defb 5,C5,1,0, 5,C5,1,0, 5,G4,1,0, 5,G4,1,0
	defb 5,A4,1,0, 5,A4,1,0, 5,B4,1,0, 5,B4,1,0
	defb 30,C5, 18,0
    defb 0
Sound_GameOver_: public Sound_GameOver_
    mov si,over_notes
jmp Melody


C4 equ 1
C4S equ 2
D4 equ 3
D4S equ 4
E4 equ 5
F4 equ 6
F4S equ 7
G4 equ 8
G4S equ 9
A4 equ 10
A4S equ 11
B4 equ 12
C5 equ 13
C5S equ 14
D5 equ 15
D5S equ 16
E5 equ 17
F5 equ 18

cycles:
defw 1177,1000000/tempo/1177 ; C4
defw 1111,1000000/tempo/1111 ; C4S
defw 1048,1000000/tempo/1048 ; D4
defw 989,1000000/tempo/989 ; D4S
defw 934,1000000/tempo/934 ; E4
defw 881,1000000/tempo/881 ; F4
defw 832,1000000/tempo/832 ; F4S
defw 785,1000000/tempo/785 ; G4
defw 741,1000000/tempo/741 ; G4S
defw 700,1000000/tempo/700 ; A4
defw 660,1000000/tempo/660 ; A4S
defw 623,1000000/tempo/623 ; B4
defw 588,1000000/tempo/588 ; C5
defw 555,1000000/tempo/555 ; C5S
defw 524,1000000/tempo/524 ; D5
defw 494,1000000/tempo/494 ; D5S
defw 467,1000000/tempo/467 ; E5
defw 440,1000000/tempo/440 ; F5
