include "VVram.inc"

ext VVram_
ext CellMap_

ColumnCount equ 12
FloorCount equ 4
ColumnsPerByte equ 2
FloorHeight equ 4
ColumnWidth equ 2

Cell_Space equ 0
Cell_LowerMask equ 3
Cell_CrackedFloor equ 1
Cell_HardFloor equ 3
Cell_LadderDown equ 2
Cell_UpperMask equ 0ch
Cell_BrokenFloor equ 4
Cell_LadderUp equ 8
Cell_Item equ 0ch

Char_Space equ 0
Char_ItemLT equ 60h
Char_ItemRT equ 90h
Char_ItemLB equ 90h
Char_ItemRB equ 60h
Char_HoleL equ 80h 
Char_HoleR equ 00h
Char_HardFloor equ 0f0h
Char_LadderL equ 0e0h
Char_LadderR equ 0d0h
Char_CrackL equ 0e0h
Char_CrackR equ 70h


; ptr<byte> CellMapPtr(byte column, byte floor);
cseg
CellMapPtr_: public CellMapPtr_
    push dx
        shr al,1
        mov dh,al
        mov al,6
        mul dl
        mov dl,dh
        xor dh,dh
        add ax,dx
        add ax,CellMap_
    pop dx
ret


; void MapToVVram();
cseg
MapToVVram_Row:
    mov [di],dx
    add di,VVramWidth
ret
MapToVVram_Rows:
    do
        call MapToVVram_Row
        dec cl
    while nz | wend
ret
MapToVVram_: public MapToVVram_
    push ax | push bx | push cx | push dx | push si | push di
        mov di,VVram_
        mov si,CellMap_
        mov bh,FloorCount
        do
            mov bl,ColumnCount/ColumnsPerByte
            do
                mov ah,[si] | inc si
                mov ch,ColumnsPerByte
                do
                    mov al,ah
                    and al,Cell_UpperMask
                    cmp al,Cell_BrokenFloor
                    if e
                        mov dx,Char_Space or Char_Space shl 8
                        mov cl,3
                        call MapToVVram_Rows
                        mov dx,Char_HoleL or Char_HoleR shl 8
                        call MapToVVram_Row
                        jmp nextColumn
                    endif
                    cmp al,Cell_Item
                    if e
                        mov dx,Char_Space or Char_Space shl 8
                        call MapToVVram_Row
                        mov dx,Char_ItemLT or Char_ItemRT shl 8
                        call MapToVVram_Row
                        mov dx,Char_ItemLB or Char_ItemRB shl 8
                        call MapToVVram_Row
                        mov dx,Char_HardFloor or Char_HardFloor shl 8
                        call MapToVVram_Row
                        jmp nextColumn
                    endif
                    cmp al,Cell_LadderUp
                    if e
                        mov dx,Char_LadderL or Char_LadderR shl 8 
                        mov cl,3
                        call MapToVVram_Rows
                        mov al,ah
                        and al,Cell_LowerMask
                        cmp al,Cell_LadderDown
                        if ne
                            mov dx,Char_HardFloor or Char_HardFloor shl 8
                        endif
                        call MapToVVram_Row
                        jmp nextColumn
                    endif
                    mov dx,Char_Space or Char_Space shl 8
                    mov cl,2
                    call MapToVVram_Rows
                        
                    mov al,ah
                    and al,Cell_LowerMask
                    cmp al,Cell_LadderDown
                    if e
                        mov dx,Char_LadderL or Char_LadderR shl 8
                        mov cl,2
                        call MapToVVram_Rows
                        jmp nextColumn
                    endif
                    mov dx,Char_Space or Char_Space shl 8
                    call MapToVVram_Row

                    mov al,ah
                    and al,Cell_LowerMask
                    cmp al,Cell_CrackedFloor
                    if e
                        mov dx,Char_CrackL or Char_CrackR shl 8
                    else
                        cmp al,Cell_HardFloor
                        if e
                            mov dx,Char_HardFloor or Char_HardFloor shl 8
                        endif
                    endif
                    call MapToVVram_Row

                    nextColumn:
                    add di,-VVramWidth*FloorHeight+2
                    shr ah,1 | shr ah,1 | shr ah,1 | shr ah,1
                    dec ch
                while nz | wend
                dec bl
            while nz | wend
            add di,VVramWidth*(FloorHeight-1)
            dec bh
        while nz | wend
    pop di | pop si | pop dx | pop cx | pop bx | pop ax
ret
